#This script set is a part of iVikodak. If you use it, kindly cite iVikodak (Citation information available at https://web.rniapps.net/iVikodak/).
library(Cairo)
x11 = function (...) grDevices::x11(...,type='cairo')
args = commandArgs(trailingOnly=TRUE)
d<-read.table(args[1],header=FALSE)
outname<-paste("Individual.Stackbar",args[2],"png",sep=".")
outname2<-paste("Individual.Stackbar.absolute",args[2],"png",sep=".")
library(ggplot2)
require(grid)
Cairo(file = outname, width = as.numeric(args[3]), height = as.numeric(args[4]), bg = "white", units = 'in',res = 300, type="png")
ggplot(d, aes(x=V4, y=V2,group=V1,fill=V1)) + geom_bar(stat ="identity",position="fill") +  theme_bw() + theme(     plot.background=element_blank()    ,panel.grid.major = element_blank()    ,panel.grid.minor = element_blank() ) + theme(axis.ticks.x=element_blank(),axis.text.x=element_blank())+ facet_grid(. ~ V3,space="free",scales="free") + theme(strip.text.x = element_text(colour = "black", size = 12)) + scale_fill_discrete(breaks = unique(d$V1)) + theme(panel.border=element_rect(color = "8", fill = NA, size = 1)) + theme(panel.margin = unit(0, "lines"))+ theme(strip.background = element_rect(colour = "white", fill = "8", size = 0.5),axis.title.x=element_blank())+scale_y_continuous(name="Relative Abundance")+ theme(legend.title=element_blank())+guides(fill=guide_legend(ncol=3))+ theme(legend.position="bottom")

dev.off()

Cairo(file = outname2, width = as.numeric(args[5]), height = as.numeric(args[6]), bg = "white", units = 'in',res = 300,type="png")
ggplot(d, aes(x=V4, y=V2,group=V1,fill=V1)) + geom_bar(stat ="identity") +  theme_bw() + theme(     plot.background=element_blank()    ,panel.grid.major = element_blank()    ,panel.grid.minor = element_blank() ) + theme(axis.ticks.x=element_blank(),axis.text.x=element_blank())+ facet_grid(. ~ V3,space="free",scales="free") + theme(strip.text.x = element_text(colour = "black", size = 12)) + scale_fill_discrete(breaks = unique(d$V1)) + theme(panel.border=element_rect(color = "8", fill = NA, size = 1)) + theme(panel.margin = unit(0, "lines"))+ theme(strip.background = element_rect(colour = "white", fill = "8", size = 0.5),axis.title.x=element_blank())+scale_y_continuous(name="Relative Abundance")+ theme(legend.title=element_blank())+guides(fill=guide_legend(ncol=3))+ theme(legend.position="bottom")

dev.off()
